Bug 1082409 - Major regression in usability of go package
Major regression in usability of go package
Status: RESOLVED FIXED
Classification: openSUSE
Product: openSUSE Tumbleweed
Classification: openSUSE
Component: Development
Current
Other Other
: P5 - None : Normal (vote)
: ---
Assigned To: Jordi Massaguer
E-mail List
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2018-02-22 21:07 UTC by Duncan Mac-Vicar
Modified: 2022-02-15 21:55 UTC (History)
4 users (show)

See Also:
Found By: ---
Services Priority:
Business Priority:
Blocker: ---
Marketing QA Status: ---
IT Deployment: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Duncan Mac-Vicar 2018-02-22 21:07:02 UTC
By accident I discovered that I could not compile software because my go was pointing to go1.4

scanner_test.go:7:2: cannot find package "github.com/dmacvicar/someproject" in any of:
        /usr/lib64/go1.4/src/github.com/dmacvicar/someproject (from $GOROOT)

I never installed go1.4

So I tried to remove it:
$ sudo zypper rm go go1.4 go1.6
[sudo] password for root:                                                                   
Loading repository data...                                                                  
Reading installed packages...                                                               
Resolving package dependencies...                                                           
                                                                                            
The following 9 packages are going to be REMOVED:                                           
  go go1.4 go1.4-doc go1.4-race go1.6 go1.6-doc go1.6-race go-doc go-race 

I try to install go again:

$ sudo zypper in go
Loading repository data...           
Reading installed packages...                                                            
Resolving package dependencies...                             
                                              
The following 11 NEW packages are going to be installed:
  go go1.4 go1.4-doc go1.4-race go1.6 go1.6-doc go1.6-race go1.9 go1.9-doc go1.9-race go-race
                                                                                        
The following recommended package was automatically selected: 
  go1.9-doc                         

Again 1.4!

I imagined go required go1.4 or something like that, but I locked go1.4 and I was still able to install go.

I think the problem lies in that both "go" and "go1.9" provide "go = 1.9", and on top of that "go" requires "go1.9".

What is the point of the "go" package? It only confuses the solver. Every goX.X package can still "provide go". That way only the latest will get installed.

Additionally, what is the point in having go1.4 there? Is it only to build the whole chain?

Then there is a problem with GOROOT. Installing a newer go, updates the alternatives but GOROOT is still pointing to the go1.4 go.
Comment 1 Jordi Massaguer 2018-02-23 10:23:12 UTC
I think the problem is in the Supplements tag of every go-race package. It has no version so go%{version}-race gets installed for each go{version} package and go{version}-race requires go{version} and so that triggers all the go installations.

It is a theory and needs to be tested and packages need to fixed.

When I have some spare time I will fix it, unless someones else does it before :)
Comment 2 Jordi Massaguer 2018-02-24 19:01:00 UTC
https://build.opensuse.org/request/show/579829
Comment 3 Duncan Mac-Vicar 2018-02-24 23:09:45 UTC
I was going to mention that the Requires line also would be better being specific to the goX.X version, but I see you already took care of that.
Comment 4 Swamp Workflow Management 2018-02-27 13:40:08 UTC
This is an autogenerated message for OBS integration:
This bug (1082409) was mentioned in
https://build.opensuse.org/request/show/580585 Factory / go
https://build.opensuse.org/request/show/580586 Factory / go1.4
https://build.opensuse.org/request/show/580587 Factory / go1.6
https://build.opensuse.org/request/show/580588 Factory / go1.7
https://build.opensuse.org/request/show/580589 Factory / go1.8
https://build.opensuse.org/request/show/580590 Factory / go1.9
Comment 7 Swamp Workflow Management 2018-03-01 17:00:13 UTC
This is an autogenerated message for OBS integration:
This bug (1082409) was mentioned in
https://build.opensuse.org/request/show/581787 Backports:SLE-12+Backports:SLE-12-SP1 / go+go1.9
Comment 8 Swamp Workflow Management 2018-03-02 20:08:51 UTC
openSUSE-SU-2018:0588-1: An update that solves one vulnerability and has one errata is now available.

Category: security (moderate)
Bug References: 1080006,1082409
CVE References: CVE-2018-6574
Sources used:
SUSE Package Hub for SUSE Linux Enterprise 12 (src):    go-1.9.4-15.1, go1.9-1.9.4-5.1
Comment 9 Swamp Workflow Management 2018-03-02 20:09:18 UTC
openSUSE-SU-2018:0589-1: An update that solves one vulnerability and has one errata is now available.

Category: security (moderate)
Bug References: 1080006,1082409
CVE References: CVE-2018-6574
Sources used:
openSUSE Leap 42.3 (src):    go-1.9.4-33.1, go1.9-1.9.4-5.1
Comment 12 Swamp Workflow Management 2018-03-07 11:11:44 UTC
openSUSE-SU-2018:0628-1: An update that solves one vulnerability and has one errata is now available.

Category: security (moderate)
Bug References: 1080006,1082409
CVE References: CVE-2018-6574
Sources used:
openSUSE Leap 42.3 (src):    go1.8-1.8.7-5.1
Comment 13 Swamp Workflow Management 2018-03-07 11:12:28 UTC
openSUSE-SU-2018:0629-1: An update that solves one vulnerability and has one errata is now available.

Category: security (moderate)
Bug References: 1080006,1082409
CVE References: CVE-2018-6574
Sources used:
SUSE Package Hub for SUSE Linux Enterprise 12 (src):    go1.8-1.8.7-5.1
Comment 15 Swamp Workflow Management 2018-03-07 13:50:10 UTC
This is an autogenerated message for OBS integration:
This bug (1082409) was mentioned in
https://build.opensuse.org/request/show/583882 15.0 / go1.8
https://build.opensuse.org/request/show/583884 15.0 / go
Comment 16 Swamp Workflow Management 2018-05-07 09:40:06 UTC
This is an autogenerated message for OBS integration:
This bug (1082409) was mentioned in
https://build.opensuse.org/request/show/604994 15.0 / go1.7
Comment 17 Andreas Stieger 2018-05-07 10:00:15 UTC
Saw this submitted to Leap 42.3, while being maintained in SLE. Do you want to front-run the Leap 42.3 update or take/copy the SLE 12 go1.7 update from the update channel when it is submitted, tested and released?
Comment 18 Jordi Massaguer 2018-05-07 10:18:32 UTC
(In reply to Andreas Stieger from comment #17)
> Saw this submitted to Leap 42.3, while being maintained in SLE. Do you want
> to front-run the Leap 42.3 update or take/copy the SLE 12 go1.7 update from
> the update channel when it is submitted, tested and released?

I just submitted the one for SLE12: sr#164494

@Andreas: Which is the sipmlest way to proceed?

I can revoke the ones for Leap if that is easier, I don't mind.
Comment 19 Swamp Workflow Management 2018-05-07 10:30:05 UTC
This is an autogenerated message for OBS integration:
This bug (1082409) was mentioned in
https://build.opensuse.org/request/show/605066 42.3+Backports:SLE-12 / go1.7
Comment 21 Andreas Stieger 2018-05-07 11:12:39 UTC
Will come from SLE maintenance
Comment 23 Swamp Workflow Management 2018-05-17 17:00:53 UTC
This is an autogenerated message for OBS integration:
This bug (1082409) was mentioned in
https://build.opensuse.org/request/show/610123 Factory / go1.10
Comment 27 Swamp Workflow Management 2018-11-09 23:25:18 UTC
openSUSE-RU-2018:3711-1: An update that has one recommended fix can now be installed.

Category: recommended (moderate)
Bug References: 1082409
CVE References: 
Sources used:
openSUSE Leap 42.3 (src):    go1.7-1.7.5-5.1
Comment 32 Swamp Workflow Management 2018-12-15 08:41:01 UTC
This is an autogenerated message for OBS integration:
This bug (1082409) was mentioned in
https://build.opensuse.org/request/show/658307 Factory / go1.10
https://build.opensuse.org/request/show/658308 Factory / go1.11
Comment 34 Swamp Workflow Management 2018-12-17 15:41:33 UTC
This is an autogenerated message for OBS integration:
This bug (1082409) was mentioned in
https://build.opensuse.org/request/show/658934 15.0+42.3 / go1.11
Comment 35 Swamp Workflow Management 2018-12-22 23:08:51 UTC
openSUSE-SU-2018:4255-1: An update that solves three vulnerabilities and has 5 fixes is now available.

Category: security (important)
Bug References: 1082409,1098017,1113978,1118897,1118898,1118899,1119634,1119706
CVE References: CVE-2018-16873,CVE-2018-16874,CVE-2018-16875
Sources used:
openSUSE Leap 42.3 (src):    go1.10-1.10.7-5.1
Comment 36 Swamp Workflow Management 2019-02-27 11:00:59 UTC
This is an autogenerated message for OBS integration:
This bug (1082409) was mentioned in
https://build.opensuse.org/request/show/679777 Factory / go1.11
Comment 37 Swamp Workflow Management 2019-03-25 11:10:53 UTC
This is an autogenerated message for OBS integration:
This bug (1082409) was mentioned in
https://build.opensuse.org/request/show/688187 Factory / go1.12
Comment 41 Aleksa Sarai 2019-07-22 22:24:44 UTC
We fixed this some time ago, as well as fixing most of the whole update-alternatives mess.
Comment 43 Swamp Workflow Management 2020-05-19 16:19:16 UTC
SUSE-RU-2020:1341-1: An update that has four recommended fixes can now be installed.

Category: recommended (moderate)
Bug References: 1082409,1119634,1121397,974800
CVE References: 
Sources used:
SUSE Linux Enterprise Module for Open Buildservice Development Tools 15-SP1 (src):    go1.9-1.9.7-3.6.2

NOTE: This line indicates an update has been released for the listed product(s). At times this might be only a partial fix. If you have questions please reach out to maintenance coordination.
Comment 44 Swamp Workflow Management 2020-05-26 13:20:36 UTC
openSUSE-RU-2020:0718-1: An update that has four recommended fixes can now be installed.

Category: recommended (moderate)
Bug References: 1082409,1119634,1121397,974800
CVE References: 
Sources used:
openSUSE Leap 15.1 (src):    go1.9-1.9.7-lp151.2.3.1
Comment 45 Swamp Workflow Management 2020-06-04 01:14:09 UTC
openSUSE-RU-2020:0768-1: An update that has four recommended fixes can now be installed.

Category: recommended (moderate)
Bug References: 1082409,1119634,1121397,974800
CVE References: 
Sources used:
openSUSE Backports SLE-15-SP1 (src):    go1.9-1.9.7-bp151.2.3.1